--TODO List
--Add scoring
--Fix Random Velocitys, because they can sometimes be 0....



--[[----------------------------------------------------------------------------------
		BALL STUFF
	----------------------------------------------------------------------------------]]
--make a table to store our balls
ballList = {}

-- Deleted table with deleted.order = a large number, to compare later
local deleted = {
	order = math.huge
	}
	
-- Sorts the object list and removes deleted objects
function ballList.sort()
	-- sort by the order, deleted will always be math.huge and be at the end!
	table.sort(ballList, function(a,b) return a.order < b.order end)
	local last = #ballList
	while ballList[last] == deleted do
		ballList[last] = nil
		last = last - 1
	end
end
	
--make a Ball class
local Ball = {}
--not sure what we are doing here, creating a variable within itself that links to itself...?
Ball.__index = Ball

function Ball:new(x, y, r, h, v)
	local ball = setmetatable( {}, Ball )
	ball.x = x or width/2
	ball.y = y or height/2
	ball.r = r or 10	
	--horizontal velocity
	ball.h = h or math.random(-5,5)
	--vertical velocity
	ball.v = v or math.random(-5,5)
	--need this to compare in sort!
	ball.order = math.random()
	--color!
	ball.color = {255*math.random(), 255*math.random(), 255*math.random()}
	ball.stepsToPaddle = 0
	ball.isTarget = false
	return ball
end

function Ball:update()
	--checking vertical bounds, first time using ipairs, not sure if we can do that or just pairs or at all...
	for i, v in ipairs(ballList) do
		--we scored on the top player
		if self.y <= 0 then
		    --delete the ball
			self:delete()
			--update score
			bottomScore = bottomScore + 1
			--modify paddle width
			paddleList[1].w = paddleList[1].w + 3
			paddleList[2].w = paddleList[2].w - 3
			if paddleList[2].w < 9 then
				paddleList[2].w = 9
			end
			
			
		end
		--we scored on the bottom player
		if self.y >= height then
			self:delete()
			topScore = topScore + 1
			paddleList[1].w = paddleList[1].w - 3
			paddleList[2].w = paddleList[2].w + 3
			if paddleList[1].w < 9 then
				paddleList[1].w = 9
			end
		end
	end
	--end vertical

	--checking horizontal bounds
	if self.x < 0 + self.r then
		self.h = self.h * -1
	end
	
	if self.x > width - self.r then
		self.h = self.h * -1
	end		
	--end horizontal
	
	self.x = self.x + self.h
	self.y = self.y + self.v
end
	
function Ball:draw()
	love.graphics.setColor(self.color)
	love.graphics.circle("fill", self.x, self.y, self.r, 100) 
end

function Ball:delete()
	--go through the ballList and find myself
	for i = 1,#ballList do
        if ballList[i] == self then
            ballList[i] = deleted
        end
    end
end

function Ball:bounce()
	self.v = self.v * -1
end
		

--[[ ----------------------------------------------------------------------------------
      PADDLE STUFF
	  ----------------------------------------------------------------------------------]]
paddleList = {}
local Paddle = {}
Paddle.__index = Paddle

function Paddle:new(x, y, w, h)
    local paddle = setmetatable( {}, Paddle)
	paddle.x = x
	paddle.y = y
	paddle.w = w
	paddle.h = h
	return paddle
end

function Paddle:update(x)
	--move my paddle horizontally, accepts a value from keypressed()
	self.x = self.x + x
	if self.x < 0 then
		self.x = 0
	elseif self.x > width - self.w then
		self.x = width - self.w
	end
end

function Paddle:draw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
end
--[[-----------------------------
	OTHER STUFF
--------------------------------]]
function findTargetBall()
	--table to store our potential balls
	local potentialTargets = {}
	--index for our table above
	local j = 1

	for i = 1, #ballList do
		if ballList[i].v > 0 then
			--store all the balls moving down in our table
			potentialTargets[j] = ballList[i]
			j = j + 1
		end
	end

	for i = 1, #potentialTargets do
		--store our potentialTargets Y so we don't change it
		local y = potentialTargets[i].y
			--compare the y to our paddles
			while  y <= paddleList[2].y do
				--as long as its not passed our paddle we add some velocity
				y = y + potentialTargets[i].v
				--and count the steps
				potentialTargets[i].stepsToPaddle = potentialTargets[i].stepsToPaddle + 1
			end
		--now we sort by the steps putting the smallest in the front
		table.sort(potentialTargets, function(a,b) return a.stepsToPaddle < b.stepsToPaddle end)
	end
	
	for i = 1, #ballList do
		if ballList[i] == potentialTargets[1] then
			ballList[i].isTarget = true
		else
			ballList[i].isTarget = false
		end
	end
	
end

function checkBounce()
	for i = 1, #ballList do
		if ballList[i].x then 
		--BOTTOM PADDLE
			--right of ball, left of paddle
			if ballList[i].x + ballList[i].r > paddleList[2].x
			--left of ball and right of paddle
			and ballList[i].x - ballList[i].r < paddleList[2].x + paddleList[2].w
			--bottom of ball and bottom of paddle
			and ballList[i].y + ballList[i].r < paddleList[2].y + paddleList[2].h
			--bottom of ball and top of paddle
			and ballList[i].y + ballList[i].r > paddleList[2].y then
				ballList[i]:bounce()
			end
			
			--right of ball and left of paddle
			if ballList[i].x + ballList[i].r > paddleList[1].x
			--left of ball and right of paddle
			and ballList[i].x - ballList[i].r < paddleList[1].x + paddleList[1].w
			--top of  ball and bottom of paddle
			and ballList[i].y - ballList[i].r < paddleList[1].y + paddleList[1].h
			--top of ball and top of paddle
			and ballList[i].y - ballList[i].r > paddleList[1].y then
				ballList[i]:bounce()
			end
			
		end
	end
end

			
--[[ ----------------------------------------------------------------------------------
      LOVE STUFF
	  ----------------------------------------------------------------------------------]]


function love.load()
	love.graphics.setBackgroundColor(0, 0, 0)
	height = love.graphics.getHeight()
	width = love.graphics.getWidth()
	--create the top paddle, remember Width then height!!
	paddleList[#paddleList+1] = Paddle:new(width/2, 10, 55, 10)
	--create the bottom paddle!
	paddleList[#paddleList+1] = Paddle:new(width/2, height - 20, 55, 10)
	
	--scoring
	topScore = 0
	bottomScore = 0
end

function love.keypressed(key)
	if key == "w" then
		ballList[#ballList+1] = Ball:new(x,y)
	end
	
end

function love.draw()
	--go through our table of balls and draw them!
	for i = 1, #ballList do
		if ballList[i].draw then 
			ballList[i]:draw()
		end
	end
	--draw our paddles
	for i = 1, #paddleList do
		if paddleList[i].draw then
			paddleList[i]:draw()
		end
	end
	--draw our score
	love.graphics.print("Top Score: ", 25, 50)
	love.graphics.print(topScore , 100, 50)
	love.graphics.print("Bot Score: ", width - 100, height - 50)
	love.graphics.print(bottomScore , width - 25, height - 50)
end
		
	
function love.update(dt)
	--no balls left? make a new one!
	if #ballList == 0 then
		ballList[#ballList+1] = Ball:new(x,y)
	end
	
	--check for bouncing balls
	checkBounce()
		
	--get our paddle inputs
    if love.keyboard.isDown("a") then
		paddleList[1]:update(-5)
	end
	
	if love.keyboard.isDown("d") then
		paddleList[1]:update(5)
	end
	
	
	--update our balls
	for i = 1,#ballList do
        if ballList[i].update then 
			ballList[i]:update() 
		end
    end
    ballList.sort()
	findTargetBall()
	
	--AI movement
	for i = 1, #ballList do
		local x = paddleList[2].x + .5 * paddleList[2].w --center of paddle
		if ballList[i].isTarget then
			if ballList[i].x >= x then
				--if its further than 5
				if ballList[i].x - x >= 5 then
					paddleList[2]:update(4.5)
				else
					paddleList[2]:update(ballList[i].x - x)
				end
			end
			
			if ballList[i].x < x then
				--if its further than 5
				if ballList[i].x - x >= -5 then
					paddleList[2]:update(-4.5)
				else
					paddleList[2]:update(ballList[i].x - x)
				end
			end
		end
	end
	print(#ballList)
end




     